<?php
use_helper('Funkcje');
use_javascript('tooltips.js', 'last');

// *****************************************************************************
// [PRESET] navigator
//slot('navigator');
$path = array(
    __(ModulPeer::getFromShort('regp')->getNazwa()) => url_for('@regp_index'),
    $point->getNazwa() => url_for('@regp_show?point_id='.$point->getId().'&junk='.Functions::slugify($point->getNazwa())),
);
//include_partial('Common/nawigator', array('path' => $path));
//end_slot();
$_SESSION['navigator_path'] = serialize($path);

// *****************************************************************************
?>

<section class="component">
    <header class="belka">
        <h2 class="title">
            <span><?php echo __(ModulPeer::getFromShort('regp')->getNazwa()).' - '.$point->getNazwa(); ?></span>
        </h2>
    </header>

    <div id="tresc_box" class="content_tresc">

        <?php echo $reg_msg; ?>

        <?php if($sf_user->hasFlash('notice')): ?>
            <span class="notice"><?php echo __($sf_user->getFlash('notice')) ?></span>
        <?php endif; ?>
        <?php if($sf_user->hasFlash('error')): ?>
            <span class="error"><?php echo __($sf_user->getFlash('error')) ?></span>
        <?php endif; ?>

        <div style="text-align: center; padding: 10px 5px">
            <?php 
            $day_of_week = date('N');
            
            $back_browse_days = $point->getForthBrowseRoundup() ? $point->getBackBrowseDays() + $day_of_week - 1 : $point->getBackBrowseDays();
            $forth_browse_days = $point->getForthBrowseRoundup() ? $point->getForthBrowseDays() + 7 - $day_of_week : $point->getForthBrowseDays();
            
            $first_browsable_date = date('d-m-Y', strtotime('-'.$back_browse_days.' days'));
            $last_browsable_date = date('d-m-Y', strtotime('+'.$forth_browse_days.' days'));
            
            $visibility = 'hidden';
            if(strtotime($week_dates['mon']->format('d-m-Y')) > strtotime($first_browsable_date))
            {
                $visibility = 'visible';
            }
            echo link_to(__('Poprzedni tydzień'), '@regp_show_week?point_id='.$point->getId().'&junk='.Functions::slugify($point->getNazwa()).'&week='.$prev_weeks_number.'&year='.$prev_weeks_year, array('style' => 'float: left; display: block; visibility: '.$visibility.';'));
            echo link_to(__('Bieżący tydzień'), '@regp_show?point_id='.$point->getId().'&junk='.Functions::slugify($point->getNazwa()), array('style' => 'float: none; display: inline-block;'));
            $visibility = 'hidden';
            if(strtotime($week_dates['sun']->format('d-m-Y')) < strtotime($last_browsable_date))
            {
                $visibility = 'visible';
            }
            echo link_to(__('Następny tydzień'), '@regp_show_week?point_id='.$point->getId().'&junk='.Functions::slugify($point->getNazwa()).'&week='.$next_weeks_number.'&year='.$next_weeks_year, array('style' => 'float: right; display: block; visibility: '.$visibility.';'));
            ?>
        </div>

        <table class="table_list" style="border-collapse: collapse; empty-cells: hide; width: 100%;">
            <thead>
                <tr>
                    <th width="9%" valign="bottom"><?php echo __('Godziny'); ?></th>
                    <th width="13%" scope="col"><?php echo __('Poniedziałek'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['mon']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Wtorek'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['tue']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Środa'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['wed']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Czwartek'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['thu']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Piątek'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['fri']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Sobota'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['sat']->format('d-m-Y'); ?></span></th>
                    <th width="13%" scope="col"><?php echo __('Niedziela'); ?><br/><span style="color: #404040; font-weight: normal;"><?php echo $week_dates['sun']->format('d-m-Y'); ?></span></th>
                </tr>
            </thead>
            <tbody>
                <?php
                $minute = $min_minute;
                $time = mktime($min_hour, $minute);
                $iter = 0;
                $date_to = date('Y-m-d', strtotime("+1 day", strtotime($last_browsable_date))).' 00:00:00';
                $date_from = date('Y-m-d', strtotime($first_browsable_date)).' 00:00:00';
                ?>
                <?php while($time < $max_time): ?>
                    <tr <?php echo 'class="row_'.($iter % 2).'"'; ?>>
                        <th scope="row"><?php echo date('G:i', $time); ?></th>

                        <?php
                        for($i = 0; $i < 7; $i++)
                        {
                            $date = $week_dates[$dow[$i]]->format('Y-m-d');
                            $term = $date.date(' H:i:00', $time);

                            // jesli dzien nie jest wolny od pracy a ta godzina miesci sie w zakresie czasu pracy tego dnia
                            if(!in_array(date('d-m-Y', strtotime($date)), $excluded_dates) && ($start_time[$dow[$i]] <= $time) && ($stop_time[$dow[$i]] > $time))
                            {
                                $excluded = array_key_exists($point_id, $excluded_conf) && array_key_exists($i, $excluded_conf[$point_id]) && array_key_exists(date('H:i', $time), $excluded_conf[$point_id][$i]) ? $excluded_conf[$point_id][$i][date('H:i', $time)] : 0;
                                $taken = array_key_exists($term, $reg_list) ? count($reg_list[$term]) : 0;
                                $available = $config['parallel_points'] - $taken - $excluded;

                                echo '<td height="20" style="margin: 0; padding: 0 4px; background: #fff; border-width: thin; border-spacing: 2px; border-collapse: collapse; border-style: solid; border-color: silver;">';
                                echo '<div style="float: right; margin: 3px 0 0 3px;">';

                                // przycisk dodawania rejestracji o ile jest dostepna na dany termin lub klodki                                
                                if($term > date('Y-m-d').' 23:59:59' && $term < $date_to)
                                {
                                    if($available > 0)
                                    {
                                        echo link_to(image_tag('admin/add.png', array('alt' => 'add', 'title' => __('Zarejestruj sie na ten termin. Wolne miejsca: ').$available)), '@regp_new?point_id='.$point_id.'&junk='.Functions::slugify($point->getNazwa()).'&date='.str_replace('-', '_', $date).'&time='.(date('H:i', $time)), 'post=true');
                                    }
                                    else
                                    {
                                        echo image_tag('admin/top_klodka.gif', array('alt' => 'confirmed', 'style' => 'margin: 3px 3px 0 0; float: left;', 'title' => __('Wszystkie wolne miejsca zostały zajęte.')));
                                    }
                                }
                                elseif($term > $date_from && $term < $date_to)
                                {
                                    if($taken > 0)
                                    {
                                        echo image_tag('admin/top_klodka.gif', array('alt' => 'confirmed', 'style' => 'margin: 3px 3px 0 0; float: left;', 'title' => sprintf(__('Zajęte miejsca: %d / %d.'), $taken, $available + $taken)));
                                    }
                                    else
                                    {
                                        //echo image_tag('admin/add.png', array('alt' => 'add', 'title' => __('Rejestracja na ten termin niedostępna'), 'style' => 'filter: grayscale(100%);'));
                                    }
                                }
                                elseif($term >= $date_to)
                                {
                                    echo image_tag('admin/add.png', array('alt' => 'add', 'title' => __('Rejestracja na ten termin jest jeszcze niedostępna'), 'style' => 'filter: grayscale(100%) brightness(110%);'));
                                }

                                echo '</div>';
                                echo '</td>';
                            }
                            else
                            {
                                echo '<td height="20"></td>';
                            }
                        }
                        ?>

                    </tr>
                    <?php $minute += $config['interval']; ?>
                    <?php $iter++; ?>
                    <?php $time = mktime($min_hour, $minute); ?>
                <?php endwhile; ?>
            </tbody>
        </table>
    </div>    
</section>    
