<?php

/**
 * RegistrationPointTbl form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class RegistrationPointTblForm extends BaseRegistrationPointTblForm
{

    public function configure()
    {
        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'nazwa' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 485px;')),
            'opis' => new sfWidgetFormTextareaTinyMCE(array(), array('class' => 'opis', 'style' => 'width: 490px;')),
            'parallel_points' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'extra_terms' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'back_browse_days' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'forth_browse_days' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'forth_browse_roundup' => new sfWidgetFormSelect(array('choices' => array('0' => 'Nie', '1' => 'Tak')), array('class' => 'required', 'style' => 'width: 80px;')),
            'interval' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'verification_time' => new sfWidgetFormInput(array(), array('class' => 'required', 'style' => 'width: 80px;')),
            'mon_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'mon_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'tue_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'tue_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'wed_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'wed_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'thu_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'thu_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'fri_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'fri_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'sat_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'sat_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'sun_start' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'sun_stop' => new sfWidgetFormInput(array(), array('type' => 'time', 'style' => 'width: 83px;')),
            'is_publicated' => new sfWidgetFormInputHidden(),
            'excluded_days' => new sfWidgetFormTextarea(array(), array('style' => 'width: 480px; height: 24px;')),
            'notice_email' => new sfWidgetFormInput(array(), array('class' => '', 'style' => 'width: 485px;')),
            'pre_registration_message' => new sfWidgetFormTextareaTinyMCE(array(), array('class' => 'pre_registration_message', 'style' => 'width: 490px;')),
            'verification_message' => new sfWidgetFormTextareaTinyMCE(array(), array('class' => 'verification_message', 'style' => 'width: 490px;')),
            'post_registration_message' => new sfWidgetFormTextareaTinyMCE(array(), array('class' => 'post_registration_message', 'style' => 'width: 490px;')),
            'created_at' => new sfWidgetFormInputHidden(),
            'updated_at' => new sfWidgetFormInputHidden(),
        ));

        $this->widgetSchema->setLabels(array(
            'nazwa' => 'Nazwa',
            'opis' => 'Opis',
            'parallel_points' => 'Ilość stanowisk',
            'extra_terms' => 'Dodatkowe terminy',
            'forth_browse_days' => 'Dostępność rejestracji',
            'forth_browse_roundup' => 'Do końca tygodnia',
            'back_browse_days' => 'Widoczność rejestracji wstecz',
            'interval' => 'Czas jednej rejestracji',
            'verification_time' => 'Czas na weryfikację rejestracji',
            'mon_start' => 'Poniedziałek',
            'tue_start' => 'Wtorek',
            'wed_start' => 'Środa',
            'thu_start' => 'Czwartek',
            'fri_start' => 'Piątek',
            'sat_start' => 'Sobota',
            'sun_start' => 'Niedziela',
            'mon_stop' => 'Poniedziałek',
            'tue_stop' => 'Wtorek',
            'wed_stop' => 'Środa',
            'thu_stop' => 'Czwartek',
            'fri_stop' => 'Piątek',
            'sat_stop' => 'Sobota',
            'sun_stop' => 'Niedziela',
            'excluded_days' => 'Dni wolne',
            'notice_email' => 'Adres powiadomienia',
            'pre_registration_message' => 'Komunikat podczas rejestracji',
            'verification_message' => 'Wiadomość weryfikacyjna',
            'post_registration_message' => 'Potwierdzenie rejestracji',
        ));

        $this->widgetSchema->setHelps(array(
            'parallel_points' => 'Ilość równolegle funkcjonujących stanowisk.',
            'extra_terms' => 'Ilość dodatkowo obsługiwanych osób w ciągu dnia.',
            'forth_browse_days' => 'Wyprzedzenie z jakim internauci mogą się rejestrować (w dniach).',
            'forth_browse_roundup' => 'Wybranie opcji `Tak` spowoduje wydłużenie możliwości przeglądania / dokonania rejestracji do początku / końca odpowiedniego tygodnia.',
            'back_browse_days' => 'Ilość dni wstecz jaką internauci mogą przeglądać historię rejestracji.',
            'interval' => 'Czas przeznaczony na obsłużenie jednej rejestracji (w minutach).',
            'verification_time' => 'Czas na weryfikację rejestracji (w godzinach).',
            'sun_start' => 'Godziny urzędowania w ciau dnia (godzina rozpoczęcia - godzina zakończenia, w formacie GG:MM).',
            'excluded_days' => 'Lista dni wolnych od pracy (w formacie DD-MM-YYYY oddzielone przecinkiem i spacją).',
            'notice_email' => 'Adres email na jaki ma zostać wysłane powiadomienie o dokonaniu rejestracji.',
            'pre_registration_message' => 'Treść komunikatu jaki zobaczą internauci podczas rejestracji.',
            'verification_message' => 'Treść wiadomości wysyłanej na adres email podany podczas rejestracji. Wiadomość powinna zawierać znaczniki <b>[AKTYWACJA] oraz [USUN]</b>, które będą zastąpione linkami aktywującymi / usuwającymi rejestrację. Ponadto może zawierać zanczniki: [IMIE], [NAZWISKO], [DATA], [GODZINA], [TELEFON], [EMAIL] i [WYDZIAL].',
            'post_registration_message' => 'Treść komunikatu potwierdzenia jaki zobaczą internauci po rejestracji. Wiadomość może zawierać znaczniki [IMIE], [NAZWISKO], [DATA], [GODZINA], [TELEFON], [EMAIL] i [WYDZIAL], które będą zastąpione odpowiednimi danymi podanymi przez osobę rejestrującą się.',
        ));

        $this->getWidgetSchema()->setDefaults(array(
            'pre_registration_message' => '<b>Witamy w internetowej rezerwacji terminu rejestracji</b><br/>Proszę wybrać dzień i godzinę wizyty a następnie podać swoje dane kontaktowe.<br/>Rezerwację należy potwierdzić w otrzymanej wiadomości e-mail.',
            'post_registration_message' => '<p><strong>Dokonano rejestracji:<br /></strong>Wydział: [WYDZIAL]<br />Osoba: [IMIE] [NAZWISKO]<br />Data: [DATA], godz. [GODZINA]<br />Telefon: [TEL]<br />Status: [STATUS]</p>',
            'verification_message' => '<p><strong>Dane rejestracji:<br /></strong>Wydział: [WYDZIAL]<br />Osoba: [IMIE] [NAZWISKO]<br />Data: [DATA], godz. [GODZINA]<br />Telefon: [TEL]</p>
<p>Twoja rezerwacja nie jest jeszcze potwierdzona. Jeśli chcesz aktywować ją teraz kliknij poniższy link:<br />[AKTYWACJA]</p>
<p>Jeśli ta wiadomość nie została wygenerowana przez Ciebie, możesz usunąć rezerwację klikając link:<br />[USUN]</p>',
            
        ));

        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->getWidgetSchema()->setNameFormat('registration_point_tbl[%s]');
    }

}