<?php

/**
 * RegistrationTbl form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class RegistrationTblForm extends BaseRegistrationTblForm
{

    public function configure()
    {
        $decorate = $this->getOption('decorate', false);
        
        $this->widgetSchema['date'] = new sfWidgetFormInput();        
        $this->widgetSchema['point_id'] = new sfWidgetFormInputHidden();        
        
        $this->widgetSchema->setLabels(array(
            'date' => 'Data rejestracji',            
            'name' => 'Imię',
            'last_name' => 'Nazwisko',
            'tel' => 'Nr telefonu',
            'email' => 'Adres e-mail',
        ));

        $this->widgetSchema->setHelps(array(
            'date' => 'Określ datę i godzinę rejestracji ( format: RRRR.MM.DD GG:MM ) ',
            'name' => 'Podaj imię osoby rejestrowanej',
            'last_name' => 'Podaj nazwisko osoby rejestrowanej',
            'tel' => 'Podaj numer telefonu osoby rejestrowanej ( format: tylko cyfry bez spacji )',
            'email' => 'Podaj adres e-mail osoby rejestrowanej, na który zostanie wysłany link aktywacyjny',
        ));

        $this->setValidators(array(
            'name' => new sfValidatorString(array('max_length' => 255, 'required' => true), array('max_length' => 'Wartość tego pola jest zbyt długa', 'required' => 'Pole wymagane')),
            'last_name' => new sfValidatorString(array('max_length' => 255, 'required' => true), array('max_length' => 'Wartość tego pola jest zbyt długa', 'required' => 'Pole wymagane')),
            'tel' => new sfValidatorInteger(array('required' => $decorate), array('required' => 'Pole wymagane', 'invalid' => 'Numer telefonu zawiera niedozwolone znaki lub jest zbyt długi (więcej niż 15 znaków)')),
            'email' => new sfValidatorEmail(array('max_length' => 255, 'required' => $decorate), array('max_length' => 'Wartość tego pola jest zbyt długa', 'required' => 'Pole wymagane', 'invalid' => 'Niepoprawny adres e-mail')),
        ));
        
        // czas rezerwacji - ze niby mozna zarezerwowac wiecej niz 1 jednostke czasu
        /*if(array_key_exists('time_span_choices', $this->options))
        {
            $this->setWidget('time_span', new sfWidgetFormChoice(array('choices' => $this->options['time_span_choices']), array('class' => 'required')));
            $this->getWidgetSchema()->setLabel('time_span', 'Czas rezerwacji');
            $this->getWidgetSchema()->setHelp('time_span', 'Określ ilość czasu');
            //$this->setValidator('time_span', new sfValidatorInteger(array('required' => true), array('required' => 'Pole wymagane', 'invalid' => 'Ilość czasu jest niepoprawna.')));            
        }*/
        
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->validatorSchema->setOption('allow_extra_fields', true);
        $this->validatorSchema->setOption('filter_extra_fields', false);
        
        if($decorate)
        {
            $this->setRequiredFields();
            $this->widgetSchema['email']->setAttribute('class', 'required');
            $this->widgetSchema['tel']->setAttribute('class', 'required');
        }
        
    }

}