<?php



class RegistrationPointTblMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.RegistrationPointTblMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(RegistrationPointTblPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(RegistrationPointTblPeer::TABLE_NAME);
		$tMap->setPhpName('RegistrationPointTbl');
		$tMap->setClassname('RegistrationPointTbl');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('NAZWA', 'Nazwa', 'VARCHAR', true, 255);

		$tMap->addColumn('OPIS', 'Opis', 'LONGVARCHAR', false, null);

		$tMap->addColumn('PARALLEL_POINTS', 'ParallelPoints', 'INTEGER', true, 3);

		$tMap->addColumn('EXTRA_TERMS', 'ExtraTerms', 'INTEGER', true, 3);

		$tMap->addColumn('BACK_BROWSE_DAYS', 'BackBrowseDays', 'INTEGER', true, 5);

		$tMap->addColumn('FORTH_BROWSE_DAYS', 'ForthBrowseDays', 'INTEGER', true, 5);

		$tMap->addColumn('FORTH_BROWSE_ROUNDUP', 'ForthBrowseRoundup', 'INTEGER', true, 1);

		$tMap->addColumn('INTERVAL', 'Interval', 'INTEGER', true, 15);

		$tMap->addColumn('VERIFICATION_TIME', 'VerificationTime', 'INTEGER', true, 5);

		$tMap->addColumn('MON_START', 'MonStart', 'VARCHAR', false, 5);

		$tMap->addColumn('MON_STOP', 'MonStop', 'VARCHAR', false, 5);

		$tMap->addColumn('TUE_START', 'TueStart', 'VARCHAR', false, 5);

		$tMap->addColumn('TUE_STOP', 'TueStop', 'VARCHAR', false, 5);

		$tMap->addColumn('WED_START', 'WedStart', 'VARCHAR', false, 5);

		$tMap->addColumn('WED_STOP', 'WedStop', 'VARCHAR', false, 5);

		$tMap->addColumn('THU_START', 'ThuStart', 'VARCHAR', false, 5);

		$tMap->addColumn('THU_STOP', 'ThuStop', 'VARCHAR', false, 5);

		$tMap->addColumn('FRI_START', 'FriStart', 'VARCHAR', false, 5);

		$tMap->addColumn('FRI_STOP', 'FriStop', 'VARCHAR', false, 5);

		$tMap->addColumn('SAT_START', 'SatStart', 'VARCHAR', false, 5);

		$tMap->addColumn('SAT_STOP', 'SatStop', 'VARCHAR', false, 5);

		$tMap->addColumn('SUN_START', 'SunStart', 'VARCHAR', false, 5);

		$tMap->addColumn('SUN_STOP', 'SunStop', 'VARCHAR', false, 5);

		$tMap->addColumn('IS_PUBLICATED', 'IsPublicated', 'INTEGER', true, 1);

		$tMap->addColumn('EXCLUDED_DAYS', 'ExcludedDays', 'LONGVARCHAR', false, null);

		$tMap->addColumn('NOTICE_EMAIL', 'NoticeEmail', 'VARCHAR', false, 255);

		$tMap->addColumn('PRE_REGISTRATION_MESSAGE', 'PreRegistrationMessage', 'LONGVARCHAR', false, null);

		$tMap->addColumn('VERIFICATION_MESSAGE', 'VerificationMessage', 'LONGVARCHAR', false, null);

		$tMap->addColumn('POST_REGISTRATION_MESSAGE', 'PostRegistrationMessage', 'LONGVARCHAR', false, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 