<?php



class RegistrationTblMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.RegistrationTblMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(RegistrationTblPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(RegistrationTblPeer::TABLE_NAME);
		$tMap->setPhpName('RegistrationTbl');
		$tMap->setClassname('RegistrationTbl');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addForeignKey('POINT_ID', 'PointId', 'INTEGER', 'registration_point_tbl', 'ID', true, 11);

		$tMap->addColumn('DATE', 'Date', 'TIMESTAMP', true, null);

		$tMap->addColumn('NAME', 'Name', 'VARCHAR', true, 255);

		$tMap->addColumn('LAST_NAME', 'LastName', 'VARCHAR', true, 255);

		$tMap->addColumn('TEL', 'Tel', 'INTEGER', false, 15);

		$tMap->addColumn('EMAIL', 'Email', 'VARCHAR', false, 255);

		$tMap->addColumn('STATUS', 'Status', 'INTEGER', true, 1);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 