<?php


abstract class BaseRegistrationPointTbl extends BaseObject  implements Persistent {


  const PEER = 'RegistrationPointTblPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $nazwa;

	
	protected $opis;

	
	protected $parallel_points;

	
	protected $extra_terms;

	
	protected $back_browse_days;

	
	protected $forth_browse_days;

	
	protected $forth_browse_roundup;

	
	protected $interval;

	
	protected $verification_time;

	
	protected $mon_start;

	
	protected $mon_stop;

	
	protected $tue_start;

	
	protected $tue_stop;

	
	protected $wed_start;

	
	protected $wed_stop;

	
	protected $thu_start;

	
	protected $thu_stop;

	
	protected $fri_start;

	
	protected $fri_stop;

	
	protected $sat_start;

	
	protected $sat_stop;

	
	protected $sun_start;

	
	protected $sun_stop;

	
	protected $is_publicated;

	
	protected $excluded_days;

	
	protected $notice_email;

	
	protected $pre_registration_message;

	
	protected $verification_message;

	
	protected $post_registration_message;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $collRegistrationTbls;

	
	private $lastRegistrationTblCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->parallel_points = 1;
		$this->extra_terms = 0;
		$this->back_browse_days = 0;
		$this->forth_browse_days = 7;
		$this->forth_browse_roundup = 0;
		$this->interval = 60;
		$this->verification_time = 24;
		$this->is_publicated = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getNazwa()
	{
		return $this->nazwa;
	}

	
	public function getOpis()
	{
		return $this->opis;
	}

	
	public function getParallelPoints()
	{
		return $this->parallel_points;
	}

	
	public function getExtraTerms()
	{
		return $this->extra_terms;
	}

	
	public function getBackBrowseDays()
	{
		return $this->back_browse_days;
	}

	
	public function getForthBrowseDays()
	{
		return $this->forth_browse_days;
	}

	
	public function getForthBrowseRoundup()
	{
		return $this->forth_browse_roundup;
	}

	
	public function getInterval()
	{
		return $this->interval;
	}

	
	public function getVerificationTime()
	{
		return $this->verification_time;
	}

	
	public function getMonStart()
	{
		return $this->mon_start;
	}

	
	public function getMonStop()
	{
		return $this->mon_stop;
	}

	
	public function getTueStart()
	{
		return $this->tue_start;
	}

	
	public function getTueStop()
	{
		return $this->tue_stop;
	}

	
	public function getWedStart()
	{
		return $this->wed_start;
	}

	
	public function getWedStop()
	{
		return $this->wed_stop;
	}

	
	public function getThuStart()
	{
		return $this->thu_start;
	}

	
	public function getThuStop()
	{
		return $this->thu_stop;
	}

	
	public function getFriStart()
	{
		return $this->fri_start;
	}

	
	public function getFriStop()
	{
		return $this->fri_stop;
	}

	
	public function getSatStart()
	{
		return $this->sat_start;
	}

	
	public function getSatStop()
	{
		return $this->sat_stop;
	}

	
	public function getSunStart()
	{
		return $this->sun_start;
	}

	
	public function getSunStop()
	{
		return $this->sun_stop;
	}

	
	public function getIsPublicated()
	{
		return $this->is_publicated;
	}

	
	public function getExcludedDays()
	{
		return $this->excluded_days;
	}

	
	public function getNoticeEmail()
	{
		return $this->notice_email;
	}

	
	public function getPreRegistrationMessage()
	{
		return $this->pre_registration_message;
	}

	
	public function getVerificationMessage()
	{
		return $this->verification_message;
	}

	
	public function getPostRegistrationMessage()
	{
		return $this->post_registration_message;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::ID;
		}

		return $this;
	} 
	
	public function setNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa !== $v) {
			$this->nazwa = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::NAZWA;
		}

		return $this;
	} 
	
	public function setOpis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->opis !== $v) {
			$this->opis = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::OPIS;
		}

		return $this;
	} 
	
	public function setParallelPoints($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->parallel_points !== $v || $v === 1) {
			$this->parallel_points = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::PARALLEL_POINTS;
		}

		return $this;
	} 
	
	public function setExtraTerms($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->extra_terms !== $v || $v === 0) {
			$this->extra_terms = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::EXTRA_TERMS;
		}

		return $this;
	} 
	
	public function setBackBrowseDays($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->back_browse_days !== $v || $v === 0) {
			$this->back_browse_days = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::BACK_BROWSE_DAYS;
		}

		return $this;
	} 
	
	public function setForthBrowseDays($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->forth_browse_days !== $v || $v === 7) {
			$this->forth_browse_days = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::FORTH_BROWSE_DAYS;
		}

		return $this;
	} 
	
	public function setForthBrowseRoundup($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->forth_browse_roundup !== $v || $v === 0) {
			$this->forth_browse_roundup = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::FORTH_BROWSE_ROUNDUP;
		}

		return $this;
	} 
	
	public function setInterval($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->interval !== $v || $v === 60) {
			$this->interval = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::INTERVAL;
		}

		return $this;
	} 
	
	public function setVerificationTime($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->verification_time !== $v || $v === 24) {
			$this->verification_time = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::VERIFICATION_TIME;
		}

		return $this;
	} 
	
	public function setMonStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->mon_start !== $v) {
			$this->mon_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::MON_START;
		}

		return $this;
	} 
	
	public function setMonStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->mon_stop !== $v) {
			$this->mon_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::MON_STOP;
		}

		return $this;
	} 
	
	public function setTueStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tue_start !== $v) {
			$this->tue_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::TUE_START;
		}

		return $this;
	} 
	
	public function setTueStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tue_stop !== $v) {
			$this->tue_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::TUE_STOP;
		}

		return $this;
	} 
	
	public function setWedStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wed_start !== $v) {
			$this->wed_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::WED_START;
		}

		return $this;
	} 
	
	public function setWedStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wed_stop !== $v) {
			$this->wed_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::WED_STOP;
		}

		return $this;
	} 
	
	public function setThuStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->thu_start !== $v) {
			$this->thu_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::THU_START;
		}

		return $this;
	} 
	
	public function setThuStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->thu_stop !== $v) {
			$this->thu_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::THU_STOP;
		}

		return $this;
	} 
	
	public function setFriStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->fri_start !== $v) {
			$this->fri_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::FRI_START;
		}

		return $this;
	} 
	
	public function setFriStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->fri_stop !== $v) {
			$this->fri_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::FRI_STOP;
		}

		return $this;
	} 
	
	public function setSatStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sat_start !== $v) {
			$this->sat_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::SAT_START;
		}

		return $this;
	} 
	
	public function setSatStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sat_stop !== $v) {
			$this->sat_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::SAT_STOP;
		}

		return $this;
	} 
	
	public function setSunStart($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sun_start !== $v) {
			$this->sun_start = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::SUN_START;
		}

		return $this;
	} 
	
	public function setSunStop($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->sun_stop !== $v) {
			$this->sun_stop = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::SUN_STOP;
		}

		return $this;
	} 
	
	public function setIsPublicated($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->is_publicated !== $v || $v === 0) {
			$this->is_publicated = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::IS_PUBLICATED;
		}

		return $this;
	} 
	
	public function setExcludedDays($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->excluded_days !== $v) {
			$this->excluded_days = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::EXCLUDED_DAYS;
		}

		return $this;
	} 
	
	public function setNoticeEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->notice_email !== $v) {
			$this->notice_email = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::NOTICE_EMAIL;
		}

		return $this;
	} 
	
	public function setPreRegistrationMessage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->pre_registration_message !== $v) {
			$this->pre_registration_message = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::PRE_REGISTRATION_MESSAGE;
		}

		return $this;
	} 
	
	public function setVerificationMessage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->verification_message !== $v) {
			$this->verification_message = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::VERIFICATION_MESSAGE;
		}

		return $this;
	} 
	
	public function setPostRegistrationMessage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->post_registration_message !== $v) {
			$this->post_registration_message = $v;
			$this->modifiedColumns[] = RegistrationPointTblPeer::POST_REGISTRATION_MESSAGE;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RegistrationPointTblPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RegistrationPointTblPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(RegistrationPointTblPeer::PARALLEL_POINTS,RegistrationPointTblPeer::EXTRA_TERMS,RegistrationPointTblPeer::BACK_BROWSE_DAYS,RegistrationPointTblPeer::FORTH_BROWSE_DAYS,RegistrationPointTblPeer::FORTH_BROWSE_ROUNDUP,RegistrationPointTblPeer::INTERVAL,RegistrationPointTblPeer::VERIFICATION_TIME,RegistrationPointTblPeer::IS_PUBLICATED))) {
				return false;
			}

			if ($this->parallel_points !== 1) {
				return false;
			}

			if ($this->extra_terms !== 0) {
				return false;
			}

			if ($this->back_browse_days !== 0) {
				return false;
			}

			if ($this->forth_browse_days !== 7) {
				return false;
			}

			if ($this->forth_browse_roundup !== 0) {
				return false;
			}

			if ($this->interval !== 60) {
				return false;
			}

			if ($this->verification_time !== 24) {
				return false;
			}

			if ($this->is_publicated !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->nazwa = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->opis = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->parallel_points = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->extra_terms = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->back_browse_days = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->forth_browse_days = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->forth_browse_roundup = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->interval = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->verification_time = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->mon_start = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->mon_stop = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
			$this->tue_start = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
			$this->tue_stop = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
			$this->wed_start = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->wed_stop = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
			$this->thu_start = ($row[$startcol + 16] !== null) ? (string) $row[$startcol + 16] : null;
			$this->thu_stop = ($row[$startcol + 17] !== null) ? (string) $row[$startcol + 17] : null;
			$this->fri_start = ($row[$startcol + 18] !== null) ? (string) $row[$startcol + 18] : null;
			$this->fri_stop = ($row[$startcol + 19] !== null) ? (string) $row[$startcol + 19] : null;
			$this->sat_start = ($row[$startcol + 20] !== null) ? (string) $row[$startcol + 20] : null;
			$this->sat_stop = ($row[$startcol + 21] !== null) ? (string) $row[$startcol + 21] : null;
			$this->sun_start = ($row[$startcol + 22] !== null) ? (string) $row[$startcol + 22] : null;
			$this->sun_stop = ($row[$startcol + 23] !== null) ? (string) $row[$startcol + 23] : null;
			$this->is_publicated = ($row[$startcol + 24] !== null) ? (int) $row[$startcol + 24] : null;
			$this->excluded_days = ($row[$startcol + 25] !== null) ? (string) $row[$startcol + 25] : null;
			$this->notice_email = ($row[$startcol + 26] !== null) ? (string) $row[$startcol + 26] : null;
			$this->pre_registration_message = ($row[$startcol + 27] !== null) ? (string) $row[$startcol + 27] : null;
			$this->verification_message = ($row[$startcol + 28] !== null) ? (string) $row[$startcol + 28] : null;
			$this->post_registration_message = ($row[$startcol + 29] !== null) ? (string) $row[$startcol + 29] : null;
			$this->created_at = ($row[$startcol + 30] !== null) ? (string) $row[$startcol + 30] : null;
			$this->updated_at = ($row[$startcol + 31] !== null) ? (string) $row[$startcol + 31] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 32; 
		} catch (Exception $e) {
			throw new PropelException("Error populating RegistrationPointTbl object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationPointTblPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RegistrationPointTblPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collRegistrationTbls = null;
			$this->lastRegistrationTblCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationPointTblPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RegistrationPointTblPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(RegistrationPointTblPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(RegistrationPointTblPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationPointTblPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RegistrationPointTblPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = RegistrationPointTblPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RegistrationPointTblPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += RegistrationPointTblPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collRegistrationTbls !== null) {
				foreach ($this->collRegistrationTbls as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = RegistrationPointTblPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRegistrationTbls !== null) {
					foreach ($this->collRegistrationTbls as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RegistrationPointTblPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNazwa();
				break;
			case 2:
				return $this->getOpis();
				break;
			case 3:
				return $this->getParallelPoints();
				break;
			case 4:
				return $this->getExtraTerms();
				break;
			case 5:
				return $this->getBackBrowseDays();
				break;
			case 6:
				return $this->getForthBrowseDays();
				break;
			case 7:
				return $this->getForthBrowseRoundup();
				break;
			case 8:
				return $this->getInterval();
				break;
			case 9:
				return $this->getVerificationTime();
				break;
			case 10:
				return $this->getMonStart();
				break;
			case 11:
				return $this->getMonStop();
				break;
			case 12:
				return $this->getTueStart();
				break;
			case 13:
				return $this->getTueStop();
				break;
			case 14:
				return $this->getWedStart();
				break;
			case 15:
				return $this->getWedStop();
				break;
			case 16:
				return $this->getThuStart();
				break;
			case 17:
				return $this->getThuStop();
				break;
			case 18:
				return $this->getFriStart();
				break;
			case 19:
				return $this->getFriStop();
				break;
			case 20:
				return $this->getSatStart();
				break;
			case 21:
				return $this->getSatStop();
				break;
			case 22:
				return $this->getSunStart();
				break;
			case 23:
				return $this->getSunStop();
				break;
			case 24:
				return $this->getIsPublicated();
				break;
			case 25:
				return $this->getExcludedDays();
				break;
			case 26:
				return $this->getNoticeEmail();
				break;
			case 27:
				return $this->getPreRegistrationMessage();
				break;
			case 28:
				return $this->getVerificationMessage();
				break;
			case 29:
				return $this->getPostRegistrationMessage();
				break;
			case 30:
				return $this->getCreatedAt();
				break;
			case 31:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RegistrationPointTblPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNazwa(),
			$keys[2] => $this->getOpis(),
			$keys[3] => $this->getParallelPoints(),
			$keys[4] => $this->getExtraTerms(),
			$keys[5] => $this->getBackBrowseDays(),
			$keys[6] => $this->getForthBrowseDays(),
			$keys[7] => $this->getForthBrowseRoundup(),
			$keys[8] => $this->getInterval(),
			$keys[9] => $this->getVerificationTime(),
			$keys[10] => $this->getMonStart(),
			$keys[11] => $this->getMonStop(),
			$keys[12] => $this->getTueStart(),
			$keys[13] => $this->getTueStop(),
			$keys[14] => $this->getWedStart(),
			$keys[15] => $this->getWedStop(),
			$keys[16] => $this->getThuStart(),
			$keys[17] => $this->getThuStop(),
			$keys[18] => $this->getFriStart(),
			$keys[19] => $this->getFriStop(),
			$keys[20] => $this->getSatStart(),
			$keys[21] => $this->getSatStop(),
			$keys[22] => $this->getSunStart(),
			$keys[23] => $this->getSunStop(),
			$keys[24] => $this->getIsPublicated(),
			$keys[25] => $this->getExcludedDays(),
			$keys[26] => $this->getNoticeEmail(),
			$keys[27] => $this->getPreRegistrationMessage(),
			$keys[28] => $this->getVerificationMessage(),
			$keys[29] => $this->getPostRegistrationMessage(),
			$keys[30] => $this->getCreatedAt(),
			$keys[31] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RegistrationPointTblPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNazwa($value);
				break;
			case 2:
				$this->setOpis($value);
				break;
			case 3:
				$this->setParallelPoints($value);
				break;
			case 4:
				$this->setExtraTerms($value);
				break;
			case 5:
				$this->setBackBrowseDays($value);
				break;
			case 6:
				$this->setForthBrowseDays($value);
				break;
			case 7:
				$this->setForthBrowseRoundup($value);
				break;
			case 8:
				$this->setInterval($value);
				break;
			case 9:
				$this->setVerificationTime($value);
				break;
			case 10:
				$this->setMonStart($value);
				break;
			case 11:
				$this->setMonStop($value);
				break;
			case 12:
				$this->setTueStart($value);
				break;
			case 13:
				$this->setTueStop($value);
				break;
			case 14:
				$this->setWedStart($value);
				break;
			case 15:
				$this->setWedStop($value);
				break;
			case 16:
				$this->setThuStart($value);
				break;
			case 17:
				$this->setThuStop($value);
				break;
			case 18:
				$this->setFriStart($value);
				break;
			case 19:
				$this->setFriStop($value);
				break;
			case 20:
				$this->setSatStart($value);
				break;
			case 21:
				$this->setSatStop($value);
				break;
			case 22:
				$this->setSunStart($value);
				break;
			case 23:
				$this->setSunStop($value);
				break;
			case 24:
				$this->setIsPublicated($value);
				break;
			case 25:
				$this->setExcludedDays($value);
				break;
			case 26:
				$this->setNoticeEmail($value);
				break;
			case 27:
				$this->setPreRegistrationMessage($value);
				break;
			case 28:
				$this->setVerificationMessage($value);
				break;
			case 29:
				$this->setPostRegistrationMessage($value);
				break;
			case 30:
				$this->setCreatedAt($value);
				break;
			case 31:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RegistrationPointTblPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNazwa($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setOpis($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setParallelPoints($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setExtraTerms($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setBackBrowseDays($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setForthBrowseDays($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setForthBrowseRoundup($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setInterval($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setVerificationTime($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setMonStart($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setMonStop($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setTueStart($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setTueStop($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setWedStart($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setWedStop($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setThuStart($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setThuStop($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setFriStart($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setFriStop($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setSatStart($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setSatStop($arr[$keys[21]]);
		if (array_key_exists($keys[22], $arr)) $this->setSunStart($arr[$keys[22]]);
		if (array_key_exists($keys[23], $arr)) $this->setSunStop($arr[$keys[23]]);
		if (array_key_exists($keys[24], $arr)) $this->setIsPublicated($arr[$keys[24]]);
		if (array_key_exists($keys[25], $arr)) $this->setExcludedDays($arr[$keys[25]]);
		if (array_key_exists($keys[26], $arr)) $this->setNoticeEmail($arr[$keys[26]]);
		if (array_key_exists($keys[27], $arr)) $this->setPreRegistrationMessage($arr[$keys[27]]);
		if (array_key_exists($keys[28], $arr)) $this->setVerificationMessage($arr[$keys[28]]);
		if (array_key_exists($keys[29], $arr)) $this->setPostRegistrationMessage($arr[$keys[29]]);
		if (array_key_exists($keys[30], $arr)) $this->setCreatedAt($arr[$keys[30]]);
		if (array_key_exists($keys[31], $arr)) $this->setUpdatedAt($arr[$keys[31]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RegistrationPointTblPeer::DATABASE_NAME);

		if ($this->isColumnModified(RegistrationPointTblPeer::ID)) $criteria->add(RegistrationPointTblPeer::ID, $this->id);
		if ($this->isColumnModified(RegistrationPointTblPeer::NAZWA)) $criteria->add(RegistrationPointTblPeer::NAZWA, $this->nazwa);
		if ($this->isColumnModified(RegistrationPointTblPeer::OPIS)) $criteria->add(RegistrationPointTblPeer::OPIS, $this->opis);
		if ($this->isColumnModified(RegistrationPointTblPeer::PARALLEL_POINTS)) $criteria->add(RegistrationPointTblPeer::PARALLEL_POINTS, $this->parallel_points);
		if ($this->isColumnModified(RegistrationPointTblPeer::EXTRA_TERMS)) $criteria->add(RegistrationPointTblPeer::EXTRA_TERMS, $this->extra_terms);
		if ($this->isColumnModified(RegistrationPointTblPeer::BACK_BROWSE_DAYS)) $criteria->add(RegistrationPointTblPeer::BACK_BROWSE_DAYS, $this->back_browse_days);
		if ($this->isColumnModified(RegistrationPointTblPeer::FORTH_BROWSE_DAYS)) $criteria->add(RegistrationPointTblPeer::FORTH_BROWSE_DAYS, $this->forth_browse_days);
		if ($this->isColumnModified(RegistrationPointTblPeer::FORTH_BROWSE_ROUNDUP)) $criteria->add(RegistrationPointTblPeer::FORTH_BROWSE_ROUNDUP, $this->forth_browse_roundup);
		if ($this->isColumnModified(RegistrationPointTblPeer::INTERVAL)) $criteria->add(RegistrationPointTblPeer::INTERVAL, $this->interval);
		if ($this->isColumnModified(RegistrationPointTblPeer::VERIFICATION_TIME)) $criteria->add(RegistrationPointTblPeer::VERIFICATION_TIME, $this->verification_time);
		if ($this->isColumnModified(RegistrationPointTblPeer::MON_START)) $criteria->add(RegistrationPointTblPeer::MON_START, $this->mon_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::MON_STOP)) $criteria->add(RegistrationPointTblPeer::MON_STOP, $this->mon_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::TUE_START)) $criteria->add(RegistrationPointTblPeer::TUE_START, $this->tue_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::TUE_STOP)) $criteria->add(RegistrationPointTblPeer::TUE_STOP, $this->tue_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::WED_START)) $criteria->add(RegistrationPointTblPeer::WED_START, $this->wed_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::WED_STOP)) $criteria->add(RegistrationPointTblPeer::WED_STOP, $this->wed_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::THU_START)) $criteria->add(RegistrationPointTblPeer::THU_START, $this->thu_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::THU_STOP)) $criteria->add(RegistrationPointTblPeer::THU_STOP, $this->thu_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::FRI_START)) $criteria->add(RegistrationPointTblPeer::FRI_START, $this->fri_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::FRI_STOP)) $criteria->add(RegistrationPointTblPeer::FRI_STOP, $this->fri_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::SAT_START)) $criteria->add(RegistrationPointTblPeer::SAT_START, $this->sat_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::SAT_STOP)) $criteria->add(RegistrationPointTblPeer::SAT_STOP, $this->sat_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::SUN_START)) $criteria->add(RegistrationPointTblPeer::SUN_START, $this->sun_start);
		if ($this->isColumnModified(RegistrationPointTblPeer::SUN_STOP)) $criteria->add(RegistrationPointTblPeer::SUN_STOP, $this->sun_stop);
		if ($this->isColumnModified(RegistrationPointTblPeer::IS_PUBLICATED)) $criteria->add(RegistrationPointTblPeer::IS_PUBLICATED, $this->is_publicated);
		if ($this->isColumnModified(RegistrationPointTblPeer::EXCLUDED_DAYS)) $criteria->add(RegistrationPointTblPeer::EXCLUDED_DAYS, $this->excluded_days);
		if ($this->isColumnModified(RegistrationPointTblPeer::NOTICE_EMAIL)) $criteria->add(RegistrationPointTblPeer::NOTICE_EMAIL, $this->notice_email);
		if ($this->isColumnModified(RegistrationPointTblPeer::PRE_REGISTRATION_MESSAGE)) $criteria->add(RegistrationPointTblPeer::PRE_REGISTRATION_MESSAGE, $this->pre_registration_message);
		if ($this->isColumnModified(RegistrationPointTblPeer::VERIFICATION_MESSAGE)) $criteria->add(RegistrationPointTblPeer::VERIFICATION_MESSAGE, $this->verification_message);
		if ($this->isColumnModified(RegistrationPointTblPeer::POST_REGISTRATION_MESSAGE)) $criteria->add(RegistrationPointTblPeer::POST_REGISTRATION_MESSAGE, $this->post_registration_message);
		if ($this->isColumnModified(RegistrationPointTblPeer::CREATED_AT)) $criteria->add(RegistrationPointTblPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(RegistrationPointTblPeer::UPDATED_AT)) $criteria->add(RegistrationPointTblPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RegistrationPointTblPeer::DATABASE_NAME);

		$criteria->add(RegistrationPointTblPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNazwa($this->nazwa);

		$copyObj->setOpis($this->opis);

		$copyObj->setParallelPoints($this->parallel_points);

		$copyObj->setExtraTerms($this->extra_terms);

		$copyObj->setBackBrowseDays($this->back_browse_days);

		$copyObj->setForthBrowseDays($this->forth_browse_days);

		$copyObj->setForthBrowseRoundup($this->forth_browse_roundup);

		$copyObj->setInterval($this->interval);

		$copyObj->setVerificationTime($this->verification_time);

		$copyObj->setMonStart($this->mon_start);

		$copyObj->setMonStop($this->mon_stop);

		$copyObj->setTueStart($this->tue_start);

		$copyObj->setTueStop($this->tue_stop);

		$copyObj->setWedStart($this->wed_start);

		$copyObj->setWedStop($this->wed_stop);

		$copyObj->setThuStart($this->thu_start);

		$copyObj->setThuStop($this->thu_stop);

		$copyObj->setFriStart($this->fri_start);

		$copyObj->setFriStop($this->fri_stop);

		$copyObj->setSatStart($this->sat_start);

		$copyObj->setSatStop($this->sat_stop);

		$copyObj->setSunStart($this->sun_start);

		$copyObj->setSunStop($this->sun_stop);

		$copyObj->setIsPublicated($this->is_publicated);

		$copyObj->setExcludedDays($this->excluded_days);

		$copyObj->setNoticeEmail($this->notice_email);

		$copyObj->setPreRegistrationMessage($this->pre_registration_message);

		$copyObj->setVerificationMessage($this->verification_message);

		$copyObj->setPostRegistrationMessage($this->post_registration_message);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getRegistrationTbls() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addRegistrationTbl($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RegistrationPointTblPeer();
		}
		return self::$peer;
	}

	
	public function clearRegistrationTbls()
	{
		$this->collRegistrationTbls = null; 	}

	
	public function initRegistrationTbls()
	{
		$this->collRegistrationTbls = array();
	}

	
	public function getRegistrationTbls($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RegistrationPointTblPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRegistrationTbls === null) {
			if ($this->isNew()) {
			   $this->collRegistrationTbls = array();
			} else {

				$criteria->add(RegistrationTblPeer::POINT_ID, $this->id);

				RegistrationTblPeer::addSelectColumns($criteria);
				$this->collRegistrationTbls = RegistrationTblPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RegistrationTblPeer::POINT_ID, $this->id);

				RegistrationTblPeer::addSelectColumns($criteria);
				if (!isset($this->lastRegistrationTblCriteria) || !$this->lastRegistrationTblCriteria->equals($criteria)) {
					$this->collRegistrationTbls = RegistrationTblPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRegistrationTblCriteria = $criteria;
		return $this->collRegistrationTbls;
	}

	
	public function countRegistrationTbls(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(RegistrationPointTblPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collRegistrationTbls === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(RegistrationTblPeer::POINT_ID, $this->id);

				$count = RegistrationTblPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RegistrationTblPeer::POINT_ID, $this->id);

				if (!isset($this->lastRegistrationTblCriteria) || !$this->lastRegistrationTblCriteria->equals($criteria)) {
					$count = RegistrationTblPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collRegistrationTbls);
				}
			} else {
				$count = count($this->collRegistrationTbls);
			}
		}
		return $count;
	}

	
	public function addRegistrationTbl(RegistrationTbl $l)
	{
		if ($this->collRegistrationTbls === null) {
			$this->initRegistrationTbls();
		}
		if (!in_array($l, $this->collRegistrationTbls, true)) { 			array_push($this->collRegistrationTbls, $l);
			$l->setRegistrationPointTbl($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collRegistrationTbls) {
				foreach ((array) $this->collRegistrationTbls as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collRegistrationTbls = null;
	}

} 