<?php


abstract class BaseRegistrationTbl extends BaseObject  implements Persistent {


  const PEER = 'RegistrationTblPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $point_id;

	
	protected $date;

	
	protected $name;

	
	protected $last_name;

	
	protected $tel;

	
	protected $email;

	
	protected $status;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $aRegistrationPointTbl;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->status = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getPointId()
	{
		return $this->point_id;
	}

	
	public function getDate($format = 'Y-m-d H:i:s')
	{
		if ($this->date === null) {
			return null;
		}


		if ($this->date === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->date, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getName()
	{
		return $this->name;
	}

	
	public function getLastName()
	{
		return $this->last_name;
	}

	
	public function getTel()
	{
		return $this->tel;
	}

	
	public function getEmail()
	{
		return $this->email;
	}

	
	public function getStatus()
	{
		return $this->status;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::ID;
		}

		return $this;
	} 
	
	public function setPointId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->point_id !== $v) {
			$this->point_id = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::POINT_ID;
		}

		if ($this->aRegistrationPointTbl !== null && $this->aRegistrationPointTbl->getId() !== $v) {
			$this->aRegistrationPointTbl = null;
		}

		return $this;
	} 
	
	public function setDate($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->date !== null || $dt !== null ) {
			
			$currNorm = ($this->date !== null && $tmpDt = new DateTime($this->date)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->date = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RegistrationTblPeer::DATE;
			}
		} 
		return $this;
	} 
	
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::NAME;
		}

		return $this;
	} 
	
	public function setLastName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->last_name !== $v) {
			$this->last_name = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::LAST_NAME;
		}

		return $this;
	} 
	
	public function setTel($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tel !== $v) {
			$this->tel = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::TEL;
		}

		return $this;
	} 
	
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::EMAIL;
		}

		return $this;
	} 
	
	public function setStatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 0) {
			$this->status = $v;
			$this->modifiedColumns[] = RegistrationTblPeer::STATUS;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RegistrationTblPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = RegistrationTblPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(RegistrationTblPeer::STATUS))) {
				return false;
			}

			if ($this->status !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->point_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->date = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->name = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->last_name = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->tel = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->email = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->status = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->created_at = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->updated_at = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 10; 
		} catch (Exception $e) {
			throw new PropelException("Error populating RegistrationTbl object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aRegistrationPointTbl !== null && $this->point_id !== $this->aRegistrationPointTbl->getId()) {
			$this->aRegistrationPointTbl = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationTblPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = RegistrationTblPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aRegistrationPointTbl = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationTblPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			RegistrationTblPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(RegistrationTblPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(RegistrationTblPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(RegistrationTblPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			RegistrationTblPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aRegistrationPointTbl !== null) {
				if ($this->aRegistrationPointTbl->isModified() || $this->aRegistrationPointTbl->isNew()) {
					$affectedRows += $this->aRegistrationPointTbl->save($con);
				}
				$this->setRegistrationPointTbl($this->aRegistrationPointTbl);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = RegistrationTblPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RegistrationTblPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += RegistrationTblPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aRegistrationPointTbl !== null) {
				if (!$this->aRegistrationPointTbl->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aRegistrationPointTbl->getValidationFailures());
				}
			}


			if (($retval = RegistrationTblPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RegistrationTblPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getPointId();
				break;
			case 2:
				return $this->getDate();
				break;
			case 3:
				return $this->getName();
				break;
			case 4:
				return $this->getLastName();
				break;
			case 5:
				return $this->getTel();
				break;
			case 6:
				return $this->getEmail();
				break;
			case 7:
				return $this->getStatus();
				break;
			case 8:
				return $this->getCreatedAt();
				break;
			case 9:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = RegistrationTblPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getPointId(),
			$keys[2] => $this->getDate(),
			$keys[3] => $this->getName(),
			$keys[4] => $this->getLastName(),
			$keys[5] => $this->getTel(),
			$keys[6] => $this->getEmail(),
			$keys[7] => $this->getStatus(),
			$keys[8] => $this->getCreatedAt(),
			$keys[9] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = RegistrationTblPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setPointId($value);
				break;
			case 2:
				$this->setDate($value);
				break;
			case 3:
				$this->setName($value);
				break;
			case 4:
				$this->setLastName($value);
				break;
			case 5:
				$this->setTel($value);
				break;
			case 6:
				$this->setEmail($value);
				break;
			case 7:
				$this->setStatus($value);
				break;
			case 8:
				$this->setCreatedAt($value);
				break;
			case 9:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = RegistrationTblPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setPointId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setDate($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setName($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setLastName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTel($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setEmail($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setStatus($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCreatedAt($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setUpdatedAt($arr[$keys[9]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(RegistrationTblPeer::DATABASE_NAME);

		if ($this->isColumnModified(RegistrationTblPeer::ID)) $criteria->add(RegistrationTblPeer::ID, $this->id);
		if ($this->isColumnModified(RegistrationTblPeer::POINT_ID)) $criteria->add(RegistrationTblPeer::POINT_ID, $this->point_id);
		if ($this->isColumnModified(RegistrationTblPeer::DATE)) $criteria->add(RegistrationTblPeer::DATE, $this->date);
		if ($this->isColumnModified(RegistrationTblPeer::NAME)) $criteria->add(RegistrationTblPeer::NAME, $this->name);
		if ($this->isColumnModified(RegistrationTblPeer::LAST_NAME)) $criteria->add(RegistrationTblPeer::LAST_NAME, $this->last_name);
		if ($this->isColumnModified(RegistrationTblPeer::TEL)) $criteria->add(RegistrationTblPeer::TEL, $this->tel);
		if ($this->isColumnModified(RegistrationTblPeer::EMAIL)) $criteria->add(RegistrationTblPeer::EMAIL, $this->email);
		if ($this->isColumnModified(RegistrationTblPeer::STATUS)) $criteria->add(RegistrationTblPeer::STATUS, $this->status);
		if ($this->isColumnModified(RegistrationTblPeer::CREATED_AT)) $criteria->add(RegistrationTblPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(RegistrationTblPeer::UPDATED_AT)) $criteria->add(RegistrationTblPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(RegistrationTblPeer::DATABASE_NAME);

		$criteria->add(RegistrationTblPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setPointId($this->point_id);

		$copyObj->setDate($this->date);

		$copyObj->setName($this->name);

		$copyObj->setLastName($this->last_name);

		$copyObj->setTel($this->tel);

		$copyObj->setEmail($this->email);

		$copyObj->setStatus($this->status);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RegistrationTblPeer();
		}
		return self::$peer;
	}

	
	public function setRegistrationPointTbl(RegistrationPointTbl $v = null)
	{
		if ($v === null) {
			$this->setPointId(NULL);
		} else {
			$this->setPointId($v->getId());
		}

		$this->aRegistrationPointTbl = $v;

						if ($v !== null) {
			$v->addRegistrationTbl($this);
		}

		return $this;
	}


	
	public function getRegistrationPointTbl(PropelPDO $con = null)
	{
		if ($this->aRegistrationPointTbl === null && ($this->point_id !== null)) {
			$c = new Criteria(RegistrationPointTblPeer::DATABASE_NAME);
			$c->add(RegistrationPointTblPeer::ID, $this->point_id);
			$this->aRegistrationPointTbl = RegistrationPointTblPeer::doSelectOne($c, $con);
			
		}
		return $this->aRegistrationPointTbl;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aRegistrationPointTbl = null;
	}

} 